import 'package:json_annotation/json_annotation.dart';
import 'package:ocg_location/ocg_location.dart';
import 'package:ocg_profile/ocg_profile.dart';

part 'customer.g.dart';

@JsonSerializable(explicitToJson: true)
class Customer extends Profile {
  final DateTime dateOfBirth;
  final List<Address> addresses;

  Customer(String id, String userId, String name, String profilePic,
      this.dateOfBirth, this.addresses)
      : super.named(id: id, userId: userId, name: name, profilePic: profilePic);

  Customer.named(
      {String id,
      String userId,
      String name,
      String profilePic,
      this.dateOfBirth,
      this.addresses})
      : super.named(id: id, userId: userId, name: name, profilePic: profilePic);

  Customer copyWith(
      {String id,
      String userId,
      String name,
      String profilePic,
      DateTime dateOfBirth,
      List<Address> addresses}) {
    return Customer.named(
      id: id ?? this.id,
      name: name ?? this.name,
      profilePic: profilePic ?? this.profilePic,
      userId: userId ?? this.userId,
      dateOfBirth: dateOfBirth ?? this.dateOfBirth,
      addresses: addresses ?? this.addresses,
    );
  }

  Map<String, dynamic> toJson() => _$CustomerToJson(this);

  factory Customer.fromJson(json) => _$CustomerFromJson(json);
}
