import 'package:ecommerce_basic/ecommerce_basic.dart';
import 'package:json_annotation/json_annotation.dart';
import 'package:ocg_location/ocg_location.dart';
import 'package:ocg_profile/ocg_profile.dart';

part 'store.g.dart';

@JsonSerializable(explicitToJson: true)
class Store extends Profile {
  final String branchId;
  final Address address;
  final List<Category> categories;
  final Rating rating;

  Store(String id, String userId, String name, String profilePic, this.branchId,
      this.address, this.categories, this.rating)
      : super.named(id: id, userId: userId, name: name, profilePic: profilePic);

  Store.named(
      {String id,
      String userId,
      String name,
      String profilePic,
      this.branchId,
      this.address,
      this.rating,
      this.categories})
      : super.named(id: id, userId: userId, name: name, profilePic: profilePic);

  Store copyWith(
          {String id,
          String userId,
          String name,
          String profilePic,
          String storeId,
          String branchId,
          Address address,
          List<Category> categories,
          Rating rating}) =>
      Store.named(
        id: id ?? this.id,
        branchId: branchId ?? this.branchId,
        userId: userId ?? this.userId,
        name: name ?? this.name,
        profilePic: profilePic ?? this.profilePic,
        rating: rating ?? this.rating,
        address: address ?? this.address,
        categories: categories ?? this.categories,
      );

  Map<String, dynamic> toJson() {
    var json = _$StoreToJson(this);
    json["categories"] = (categories ?? []).map((e) => e.id);
    return json;
  }

  factory Store.fromJson(json) => _$StoreFromJson(json);
}
