import 'package:ocg_app/ocg_app.dart';
import 'package:ecommerce_profile/src/models/store.dart';
import 'package:ecommerce_profile/src/repository/store/base.dart';

class StoreTestRepository extends StoreRepository {
  final IDHelper idHelper;
  List<Store> _list;
  StoreTestRepository(this.idHelper) : _list = [];
  Future<AppResponse<String>> create(Store customer) async {
    String id = idHelper.generateId();
    _list.add(customer.copyWith(id: id));
    return AppResponse.named(data: id);
  }

  Future<AppResponse<bool>> delete(String id) async {
    int index = _list.indexWhere((element) => element.id == id);
    if (index != -1) {
      _list.removeAt(index);
      return AppResponse.named(data: true);
    }
    return AppResponse.named(error: "Not exists");
  }

  Future<AppResponse<List<Store>>> getList(
      {int page = 1, int count = 10}) async {
    return AppResponse.named(
        data: _list.skip(count * page).take(count).toList());
  }

  Future<AppResponse<Store>> read(String id) async {
    int index = _list.indexWhere((element) => element.id == id);
    if (index != -1) {
      return AppResponse.named(data: _list[index]);
    }
    return AppResponse.named(error: "Not exists");
  }

  Future<AppResponse<bool>> update(Store object) async {
    int index = _list.indexWhere((element) => element.id == object.id);
    if (index != -1) {
      _list[index] = object;
      return AppResponse.named(data: true);
    }
    return AppResponse.named(error: "Not exists");
  }

  @override
  Future<AppResponse<Store>> getByUser(String userId) {
    // TODO: implement getByUser
    throw UnimplementedError();
  }
}
